/* KDE APM-BIOS monitor
   version 0.1.0
   1998 Herwin Jan Steehouwer and Christian Czezatke

   this source is under GPL !!
*/

#include <qtabdlg.h>
#include <qlcdnum.h>
#include <qlabel.h>
#include <qbttngrp.h>
#include <qpushbt.h>
#include <qprogbar.h>
#include <qlayout.h>
#include <kpopmenu.h>
#include <unistd.h>
#include <stdlib.h>
#include <qwindow.h>
#include <qlabel.h>
#include <qbitmap.h>
#include <kwm.h>
#include <kapp.h>
#include <kprogress.h>
#include <qpushbt.h>
#include <qpainter.h>
#include <qpicture.h>
#include <qwidget.h>
#include <qpaintd.h>
#include <qtooltip.h>
#include <fcntl.h>
#include <stdio.h>
#include <sys/types.h>
#include <qcolor.h>
#include <kiconloader.h>
#include <ctype.h>
#include <qradiobt.h>
#include <qlined.h>
#include <kbutton.h>
#include <kslider.h>

/* CC: includes for /dev/apm_bios control */
#include <qmsgbox.h>
#include <sys/ioctl.h>
#include <linux/apm_bios.h>      

/* CC: glibc systems need that for errno, should be ok on all other systems too... */
#include <errno.h>

#include "kapm.moc"

DockView   *v;

// setup standard values

char DD=1;
char RC=2;
int chkInterval=1000;  // MiliSec.
unsigned int lowBattLevel= 10;  // 10% remaining capacity raises alarm window
unsigned int old_battery_level = 100; 

batwin::batwin():
	QTabDialog(0, "tabjes")
{
   QTabDialog	*tab = this;
   QWidget *w1 = new QWidget(tab,"status");

   int height = 307;

   QPushButton *bt;
   bt=new QPushButton(tab, "help");
   bt->setGeometry(7,height-22,65,27);
   bt->setMinimumSize( 10, 10 );
   bt->setMaximumSize( 32767, 32767 );
   connect( bt, SIGNAL(clicked()), SLOT(help()) );
   bt->setText( "Help" );
   bt->setAutoRepeat( FALSE );
   bt->setAutoResize( FALSE );
   bt->setAutoDefault( FALSE );
   QPushButton *qbt;
   qbt=new QPushButton(tab,"quit");
   qbt->setGeometry(77,height-22,65,27);
   qbt->setMinimumSize( 10, 10 );
   qbt->setMaximumSize( 32767, 32767 );
   connect( qbt, SIGNAL(clicked()), SLOT(stop()) );
   qbt->setText( "Quit" );
   qbt->setAutoRepeat( FALSE );
   qbt->setAutoResize( FALSE );
   qbt->setAutoDefault( FALSE );

/*   QButtonGroup* dlgedit_ButtonGroup_1;
      dlgedit_ButtonGroup_1 = new QButtonGroup( w1, "ButtonGroup_1" );
      dlgedit_ButtonGroup_1->setGeometry( 10, 10, 360, 210 );
      dlgedit_ButtonGroup_1->setMinimumSize( 10, 10 );
      dlgedit_ButtonGroup_1->setMaximumSize( 32767, 32767 );
      dlgedit_ButtonGroup_1->setFrameStyle( 49 );
      dlgedit_ButtonGroup_1->setTitle( "" );
      dlgedit_ButtonGroup_1->setAlignment( 1 );
*/
   dlgedit_bateryLiveBar = new QProgressBar( 100, w1, "bateryLiveBar" );
   dlgedit_bateryLiveBar->setGeometry( 100, 200, 260, 30 );
   dlgedit_bateryLiveBar->setMinimumSize( 10, 10 );
   dlgedit_bateryLiveBar->setMaximumSize( 32767, 32767 );
   dlgedit_bateryLiveBar->setFrameStyle( 51 );
   dlgedit_bateryLiveBar->setLineWidth( 2 );

   dlgedit_bateryLiveBar->setTotalSteps(100);

   QLabel* dlgedit_bateryLiveLabel;
   dlgedit_bateryLiveLabel = new QLabel( w1, "bateryLiveLabel" );
   dlgedit_bateryLiveLabel->setGeometry( 20, 200, 80, 30 );
   dlgedit_bateryLiveLabel->setMinimumSize( 10, 10 );
   dlgedit_bateryLiveLabel->setMaximumSize( 32767, 32767 );
   dlgedit_bateryLiveLabel->setText( "Battery Live :" );
   dlgedit_bateryLiveLabel->setAlignment( 289 );
   dlgedit_bateryLiveLabel->setMargin( -1 );

   QLabel* dlgedit_Label_2;
   dlgedit_Label_2 = new QLabel( w1, "Label_2" );
   dlgedit_Label_2->setGeometry( 20, 20, 130, 20 );
   dlgedit_Label_2->setMinimumSize( 10, 10 );
   dlgedit_Label_2->setMaximumSize( 32767, 32767 );
   dlgedit_Label_2->setText( "APM-BIOS version:" );
   dlgedit_Label_2->setAlignment( 289 );
   dlgedit_Label_2->setMargin( -1 );

   QLabel* dlgedit_Label_3;
   dlgedit_Label_3 = new QLabel( w1, "Label_3" );
   dlgedit_Label_3->setGeometry( 20, 40, 140, 20 );
   dlgedit_Label_3->setMinimumSize( 10, 10 );
   dlgedit_Label_3->setMaximumSize( 32767, 32767 );
   dlgedit_Label_3->setText( "APM module version:" );
   dlgedit_Label_3->setAlignment( 289 );
   dlgedit_Label_3->setMargin( -1 );

/*   QPushButton* dlgedit_ButtonOK;
      dlgedit_ButtonOK = new QPushButton( w1, "ButtonOK" );
      dlgedit_ButtonOK->setGeometry( 10, 230, 100, 30 );
      dlgedit_ButtonOK->setMinimumSize( 10, 10 );
      dlgedit_ButtonOK->setMaximumSize( 32767, 32767 );
      connect( dlgedit_ButtonOK, SIGNAL(clicked()), SLOT(closeWindow()) );
      dlgedit_ButtonOK->setText( "OK" );
      dlgedit_ButtonOK->setAutoRepeat( FALSE );
      dlgedit_ButtonOK->setAutoResize( FALSE );
      dlgedit_ButtonOK->setAutoDefault( TRUE );

      QPushButton* dlgedit_ButtonStop;
      dlgedit_ButtonStop = new QPushButton( w1, "ButtonStop" );
      dlgedit_ButtonStop->setGeometry( 140, 230, 100, 30 );
      dlgedit_ButtonStop->setMinimumSize( 10, 10 );
      dlgedit_ButtonStop->setMaximumSize( 32767, 32767 );
      connect( dlgedit_ButtonStop, SIGNAL(clicked()), SLOT(stop()) );
      dlgedit_ButtonStop->setText( "Quit" );
      dlgedit_ButtonStop->setAutoRepeat( FALSE );
      dlgedit_ButtonStop->setAutoResize( FALSE );
      dlgedit_ButtonStop->setAutoDefault( TRUE );      

      QPushButton* dlgedit_ButtonHelp;
      dlgedit_ButtonHelp = new QPushButton( w1, "ButtonHelp" );
      dlgedit_ButtonHelp->setGeometry( 270, 230, 100, 30 );
      dlgedit_ButtonHelp->setMinimumSize( 10, 10 );
      dlgedit_ButtonHelp->setMaximumSize( 32767, 32767 );
      connect( dlgedit_ButtonHelp, SIGNAL(pressed()), SLOT(help()) );
      dlgedit_ButtonHelp->setText( "Help" );
      dlgedit_ButtonHelp->setAutoRepeat( FALSE );
      dlgedit_ButtonHelp->setAutoResize( FALSE );
*/
   QLabel* dlgedit_Label_4;
   dlgedit_Label_4 = new QLabel( w1, "Label_4" );
   dlgedit_Label_4->setGeometry( 20, 60, 100, 20 );
   dlgedit_Label_4->setMinimumSize( 10, 10 );
   dlgedit_Label_4->setMaximumSize( 32767, 32767 );
   dlgedit_Label_4->setText( "AC Status:" );
   dlgedit_Label_4->setAlignment( 289 );
   dlgedit_Label_4->setMargin( -1 );

   QLabel* dlgedit_Label_5;
   dlgedit_Label_5 = new QLabel( w1, "Label_5" );
   dlgedit_Label_5->setGeometry( 20, 80, 100, 20 );
   dlgedit_Label_5->setMinimumSize( 10, 10 );
   dlgedit_Label_5->setMaximumSize( 32767, 32767 );
   dlgedit_Label_5->setText( "Battery Status:" );
   dlgedit_Label_5->setAlignment( 289 );
   dlgedit_Label_5->setMargin( -1 );

   QLabel* dlgedit_Label_6;
   dlgedit_Label_6 = new QLabel( w1, "Label_6" );
   dlgedit_Label_6->setGeometry( 20, 100, 100, 20 );
   dlgedit_Label_6->setMinimumSize( 10, 10 );
   dlgedit_Label_6->setMaximumSize( 32767, 32767 );
   dlgedit_Label_6->setText( "Battery Live:" );
   dlgedit_Label_6->setAlignment( 289 );
   dlgedit_Label_6->setMargin( -1 );

   QLabel* dlgedit_Label_7;
   dlgedit_Label_7 = new QLabel( w1, "Label_7" );
   dlgedit_Label_7->setGeometry( 20, 120, 100, 20 );
   dlgedit_Label_7->setMinimumSize( 10, 10 );
   dlgedit_Label_7->setMaximumSize( 32767, 32767 );
   dlgedit_Label_7->setText( "APM Flag:" );
   dlgedit_Label_7->setAlignment( 289 );
   dlgedit_Label_7->setMargin( -1 );

   QLabel* dlgedit_Label_8;
   dlgedit_Label_8 = new QLabel( w1, "Label_8" );
   dlgedit_Label_8->setGeometry( 20, 140, 100, 20 );
   dlgedit_Label_8->setMinimumSize( 10, 10 );
   dlgedit_Label_8->setMaximumSize( 32767, 32767 );
   dlgedit_Label_8->setText( "Battery Flag:" );
   dlgedit_Label_8->setAlignment( 289 );
   dlgedit_Label_8->setMargin( -1 );

   /* CC: add remaining time */
   QLabel *dlgedit_Label_16;
   dlgedit_Label_16 = new QLabel( w1, "Label_16" );
   dlgedit_Label_16->setGeometry( 20, 160, 100, 20 );
   dlgedit_Label_16->setMinimumSize( 10, 10 );
   dlgedit_Label_16->setMaximumSize( 32767, 32767 );
   dlgedit_Label_16->setText( "Remaining Time:" );
   dlgedit_Label_16->setAlignment( 289 );
   dlgedit_Label_16->setMargin( -1 );
   

   dlgedit_Label_9 = new QLabel( w1, "Label_9" );
   dlgedit_Label_9->setGeometry( 160, 20, 100, 20 );
   dlgedit_Label_9->setMinimumSize( 10, 10 );
   dlgedit_Label_9->setMaximumSize( 32767, 32767 );
   dlgedit_Label_9->setText( " " );
   dlgedit_Label_9->setAlignment( 289 );
   dlgedit_Label_9->setMargin( -1 );


   dlgedit_Label_10 = new QLabel( w1, "Label_10" );
   dlgedit_Label_10->setGeometry( 160, 40, 100, 20 );
   dlgedit_Label_10->setMinimumSize( 10, 10 );
   dlgedit_Label_10->setMaximumSize( 32767, 32767 );
   dlgedit_Label_10->setText( " " );
   dlgedit_Label_10->setAlignment( 289 );
   dlgedit_Label_10->setMargin( -1 );

   dlgedit_Label_11 = new QLabel( w1, "Label_11" );
   dlgedit_Label_11->setGeometry( 160, 100, 200, 20 );
   dlgedit_Label_11->setMinimumSize( 10, 10 );
   dlgedit_Label_11->setMaximumSize( 32767, 32767 );
   dlgedit_Label_11->setText( " " );
   dlgedit_Label_11->setAlignment( 289 );
   dlgedit_Label_11->setMargin( -1 );
   dlgedit_Label_12 = new QLabel( w1, "Label_12" );
   dlgedit_Label_12->setGeometry( 160, 80, 200, 20 );
   dlgedit_Label_12->setMinimumSize( 10, 10 );
   dlgedit_Label_12->setMaximumSize( 32767, 32767 );
   dlgedit_Label_12->setText( " " );
   dlgedit_Label_12->setAlignment( 289 );
   dlgedit_Label_12->setMargin( -1 );

   dlgedit_LCDNumber = new QLCDNumber( w1, "LCDNumber" );
   dlgedit_LCDNumber->setGeometry( 300, 20, 60, 40 );
   dlgedit_LCDNumber->setMinimumSize( 10, 10 );
   dlgedit_LCDNumber->setMaximumSize( 32767, 32767 );
   dlgedit_LCDNumber->setFrameStyle( 33 );
   dlgedit_LCDNumber->setSmallDecimalPoint( FALSE );
   dlgedit_LCDNumber->setNumDigits( 3 );
   dlgedit_LCDNumber->setMode( QLCDNumber::DEC );
   dlgedit_LCDNumber->setSegmentStyle( QLCDNumber::Outline );

   dlgedit_Label_13 = new QLabel( w1, "Label_13" );
   dlgedit_Label_13->setGeometry( 160, 60, 200, 20 );
   dlgedit_Label_13->setMinimumSize( 10, 10 );
   dlgedit_Label_13->setMaximumSize( 32767, 32767 );
   dlgedit_Label_13->setText( " " );
   dlgedit_Label_13->setAlignment( 289 );
   dlgedit_Label_13->setMargin( -1 );

   dlgedit_Label_14 = new QLabel( w1, "Label_14" );
   dlgedit_Label_14->setGeometry( 160, 120, 200, 20 );
   dlgedit_Label_14->setMinimumSize( 10, 10 );
   dlgedit_Label_14->setMaximumSize( 32767, 32767 );
   dlgedit_Label_14->setText( " " );
   dlgedit_Label_14->setAlignment( 289 );
   dlgedit_Label_14->setMargin( -1 );

   dlgedit_Label_15 = new QLabel( w1, "Label_15" );
   dlgedit_Label_15->setGeometry( 160, 140, 200, 20 );
   dlgedit_Label_15->setMinimumSize( 10, 10 );
   dlgedit_Label_15->setMaximumSize( 32767, 32767 );
   dlgedit_Label_15->setText( " " );
   dlgedit_Label_15->setAlignment( 289 );
   dlgedit_Label_15->setMargin( -1 );

   dlgedit_Label_17 = new QLabel( w1, "Label_17" );
   dlgedit_Label_17->setGeometry( 160, 160, 200, 20 );
   dlgedit_Label_17->setMinimumSize( 10, 10 );
   dlgedit_Label_17->setMaximumSize( 32767, 32767 );
   dlgedit_Label_17->setText( " " );
   dlgedit_Label_17->setAlignment( 289 );
   dlgedit_Label_17->setMargin( -1 );


   QBoxLayout* dlgedit_layout_1 = new QBoxLayout( w1, QBoxLayout::TopToBottom, 5, 5, NULL );
   dlgedit_layout_1->addStrut( 0 );

   tab->addTab(w1,"&Status");
   w1=new QDialog(tab,"setup");

   QButtonGroup* dlgedit_ButtonGroup_3;
   dlgedit_ButtonGroup_3 = new QButtonGroup( w1, "ButtonGroup_3" );
   dlgedit_ButtonGroup_3->setGeometry( 200, 50, 180, 120 );
   dlgedit_ButtonGroup_3->setMinimumSize( 10, 10 );
   dlgedit_ButtonGroup_3->setMaximumSize( 32767, 32767 );
   dlgedit_ButtonGroup_3->setFrameStyle( 49 );
   dlgedit_ButtonGroup_3->setTitle( "On RightClick:" );
   dlgedit_ButtonGroup_3->setAlignment( 1 );

   QButtonGroup* dlgedit_ButtonGroup_2;
   dlgedit_ButtonGroup_2 = new QButtonGroup( w1, "ButtonGroup_2" );
   dlgedit_ButtonGroup_2->setGeometry( 20, 50, 170, 120 );
   dlgedit_ButtonGroup_2->setMinimumSize( 10, 10 );
   dlgedit_ButtonGroup_2->setMaximumSize( 32767, 32767 );
   dlgedit_ButtonGroup_2->setFrameStyle( 49 );
   dlgedit_ButtonGroup_2->setTitle( "On DoubleClick:" );
   dlgedit_ButtonGroup_2->setAlignment( 1 );
/*
      dlgedit_chkInterval = new QLineEdit( w1, "chkInterval" );
      dlgedit_chkInterval->setGeometry( 110, 20, 40, 20 );
      dlgedit_chkInterval->setMinimumSize( 10, 10 );
      dlgedit_chkInterval->setMaximumSize( 32767, 32767 );
      dlgedit_chkInterval->setMaxLength( 4 );
      dlgedit_chkInterval->setEchoMode( QLineEdit::Normal );
      dlgedit_chkInterval->setFrame( TRUE );

*/

   dlgedit_interval = new KSlider( w1, "interval" );
   dlgedit_interval->setGeometry( 120, 20, 260, 20 );
   dlgedit_interval->setMinimumSize( 10, 10 );
   dlgedit_interval->setMaximumSize( 32767, 32767 );
   dlgedit_interval->setOrientation( QSlider::Horizontal );
   dlgedit_interval->setRange( 0, 10000 );
   dlgedit_interval->setSteps( 500, 1000 );
   dlgedit_interval->setValue( chkInterval-1000 );
   dlgedit_interval->setTracking( TRUE );
   dlgedit_interval->setTickmarks( KSlider::NoMarks );
   dlgedit_interval->setTickInterval( 0 );



   dlgedit_DDstatus = new QRadioButton( w1, "DDstatus" );
   dlgedit_DDstatus->setGeometry( 30, 70, 150, 20 );
   dlgedit_DDstatus->setMinimumSize( 10, 10 );
   dlgedit_DDstatus->setMaximumSize( 32767, 32767 );
   dlgedit_DDstatus->setText( "Status/Setup window" );
   dlgedit_DDstatus->setAutoRepeat( FALSE );
   dlgedit_DDstatus->setAutoResize( FALSE );


   dlgedit_DDpopup = new QRadioButton( w1, "DDpopup" );
   dlgedit_DDpopup->setGeometry( 30, 100, 100, 20 );
   dlgedit_DDpopup->setMinimumSize( 10, 10 );
   dlgedit_DDpopup->setMaximumSize( 32767, 32767 );
   dlgedit_DDpopup->setText( "Popup Menu" );
   dlgedit_DDpopup->setAutoRepeat( FALSE );
   dlgedit_DDpopup->setAutoResize( FALSE );

   dlgedit_DDnone = new QRadioButton( w1, "DDnone" );
   dlgedit_DDnone->setGeometry( 30, 130, 100, 20 );
   dlgedit_DDnone->setMinimumSize( 10, 10 );
   dlgedit_DDnone->setMaximumSize( 32767, 32767 );
   dlgedit_DDnone->setText( "None" );
   dlgedit_DDnone->setAutoRepeat( FALSE );
   dlgedit_DDnone->setAutoResize( FALSE );

   dlgedit_RCnone = new QRadioButton( w1, "RCnone" );
   dlgedit_RCnone->setGeometry( 210, 130, 100, 20 );
   dlgedit_RCnone->setMinimumSize( 10, 10 );
   dlgedit_RCnone->setMaximumSize( 32767, 32767 );
   dlgedit_RCnone->setText( "None" );
   dlgedit_RCnone->setAutoRepeat( FALSE );
   dlgedit_RCnone->setAutoResize( FALSE );

   dlgedit_RCpopup = new QRadioButton( w1, "RCpopup" );
   dlgedit_RCpopup->setGeometry( 210, 100, 100, 20 );
   dlgedit_RCpopup->setMinimumSize( 10, 10 );
   dlgedit_RCpopup->setMaximumSize( 32767, 32767 );
   dlgedit_RCpopup->setText( "Popup Menu" );
   dlgedit_RCpopup->setAutoRepeat( FALSE );
   dlgedit_RCpopup->setAutoResize( FALSE );

   dlgedit_RCstatus = new QRadioButton( w1, "RCstatus" );
   dlgedit_RCstatus->setGeometry( 210, 70, 160, 20 );
   dlgedit_RCstatus->setMinimumSize( 10, 10 );
   dlgedit_RCstatus->setMaximumSize( 32767, 32767 );
   dlgedit_RCstatus->setText( "Status/Setup window" );
   dlgedit_RCstatus->setAutoRepeat( FALSE );
   dlgedit_RCstatus->setAutoResize( FALSE );

   switch(RC)
   {
      case 0:  dlgedit_RCnone->setChecked(1);
	       break;
      case 1:  dlgedit_RCstatus->setChecked(1);
	       break;
      case 2:  dlgedit_RCpopup->setChecked(1);
	       break;
   }
   switch(DD)
   {
      case 0:  dlgedit_DDnone->setChecked(1);
	       break;
      case 1:  dlgedit_DDstatus->setChecked(1);
	       break;
      case 2:  dlgedit_DDpopup->setChecked(1);
	       break;
   }

   dlgedit_interval->setValue(chkInterval);

   QLabel* dlgedit_Label_18;
   dlgedit_Label_18 = new QLabel( w1, "Label_18" );
   dlgedit_Label_18->setGeometry( 20, 20, 90, 20 );
   dlgedit_Label_18->setMinimumSize( 10, 10 );
   dlgedit_Label_18->setMaximumSize( 32767, 32767 );
   dlgedit_Label_18->setText( "Check Interval:" );
   dlgedit_Label_18->setAlignment( 289 );
   dlgedit_Label_18->setMargin( -1 );

   QLabel *dlgedit_Label_19;
   dlgedit_Label_19 = new QLabel( w1, "Label_19" );
   dlgedit_Label_19->setGeometry( 20, 180, 120, 20 );
   dlgedit_Label_19->setMinimumSize( 10, 10 );
   dlgedit_Label_19->setMaximumSize( 32767, 32767 );
   dlgedit_Label_19->setText( "Low Batt. Warning:" );
   dlgedit_Label_19->setAlignment( 289 );
   dlgedit_Label_19->setMargin( -1 );
   
   dlgedit_lowbatt = new KSlider( w1, "lowbatt" );
   dlgedit_lowbatt->setGeometry( 120, 180, 260, 20 );
   dlgedit_lowbatt->setMinimumSize( 10, 10 );
   dlgedit_lowbatt->setMaximumSize( 32767, 32767 );
   dlgedit_lowbatt->setOrientation( QSlider::Horizontal );
   dlgedit_lowbatt->setRange( 0, 100 );
   dlgedit_lowbatt->setSteps( 5, 10 );
   dlgedit_lowbatt->setValue( lowBattLevel);
   dlgedit_lowbatt->setTracking( TRUE );
   dlgedit_lowbatt->setTickmarks( KSlider::NoMarks );
   dlgedit_lowbatt->setTickInterval( 0 );


/*  QLabel* dlgedit_Label_19;
      dlgedit_Label_19 = new QLabel( w1, "Label_19" );
      dlgedit_Label_19->setGeometry( 155, 20, 70, 20 );
      dlgedit_Label_19->setMinimumSize( 10, 10 );
      dlgedit_Label_19->setMaximumSize( 32767, 32767 );
      dlgedit_Label_19->setText( "MiliSeconds" );
      dlgedit_Label_19->setAlignment( 289 );
      dlgedit_Label_19->setMargin( -1 );
*/
   dlgedit_ButtonGroup_3->insert( dlgedit_RCnone );
   dlgedit_ButtonGroup_3->insert( dlgedit_RCpopup );
   dlgedit_ButtonGroup_3->insert( dlgedit_RCstatus );

   dlgedit_ButtonGroup_2->insert( dlgedit_DDstatus );
   dlgedit_ButtonGroup_2->insert( dlgedit_DDpopup );
   dlgedit_ButtonGroup_2->insert( dlgedit_DDnone );

   tab->addTab(w1,"S&etup");


   tab->setCancelButton();
   tab->setApplyButton();


   connect(tab,SIGNAL(applyButtonPressed()),SLOT(apply()));
   connect(tab,SIGNAL(cancelButtonPressed()), SLOT(closeWindow()));
   tab->setGeometry(0,0,420,320);


   showAll();
   setFixedSize(420,320);
   show();
   startTimer(chkInterval);
}
batwin::~batwin()
{
}

void batwin::apply()
{
   KConfig *config = kapp->getConfig();

   if (dlgedit_DDnone->isChecked())   DD=0;
   if (dlgedit_DDstatus->isChecked()) DD=1;
   if (dlgedit_DDpopup->isChecked())  DD=2;
   if (dlgedit_RCnone->isChecked())   RC=0;
   if (dlgedit_RCstatus->isChecked()) RC=1;
   if (dlgedit_RCpopup->isChecked())  RC=2;
   chkInterval = dlgedit_interval->value()+1000;
   lowBattLevel= dlgedit_lowbatt->value();

   if ((0 == RC) && (0 == DD)) {
	   /* CC: neither menu nor dialog can be invoked, so the user might have
	      a hard time quitting kapm... */
	   RC = 2;
	   DD = 1;
   }
   if (config) {
	   config->setGroup("Settings");
	   config->writeEntry("ChkInterval", chkInterval);
	   config->writeEntry("RightClick", RC);
	   config->writeEntry("DoubleClick", DD);
	   config->writeEntry("LowBattWarning", lowBattLevel);
	   config->sync();
   }

   v->killTimer(v->update_timer);
   v->update_timer = v->startTimer(chkInterval);
}


void batwin::closeWindow()
{
	v->batw = 0;
	close(TRUE);
}


void batwin::done(int r)
{
	v->batw = 0;
	QTabDialog::done(r);
	delete this;
}

void batwin::stop()
{
   kapp->quit();
}
void batwin::help()
{
   kapp->invokeHTMLHelp("kapm/kapm.html","");
}



void batwin::timerEvent(QTimerEvent *)
{
   showAll();
}



void batwin::showAll(void)
{
   char tmpStr[255],tmpStr1[255];

   sprintf(tmpStr,"%d",info.bateryLive);
   /* CC: the next is a hack t get QProgressBar to update from bigger to smaller
      values. QProgressBar would normally only accept increasing values. This
      is why the progress bar did not update properly in former versions.
      (at least in Qt. 1.33 have a look at QProgressBar::setProgress
      and you'll see the problem
   */
   dlgedit_bateryLiveBar->reset();
   dlgedit_bateryLiveBar->setTotalSteps(100);
   dlgedit_bateryLiveBar->setProgress( info.bateryLive );
   dlgedit_LCDNumber->display(tmpStr);
   dlgedit_Label_9->setText( info.biosVersion);
   dlgedit_Label_10->setText( info.apmVersion);
   switch(info.ACStatus)
   {
      case 0:  sprintf(tmpStr,"Off-line");
	       break;
      case 1:  sprintf(tmpStr,"On-line");
	       break;
      case 2:  sprintf(tmpStr,"Backup Power (APM-BIOS 1.1 only)");
	       break;
      default:  sprintf(tmpStr,"Unknown");
		break;
   }
   dlgedit_Label_13->setText( tmpStr);
   switch(info.bateryStatus)
   {
      case 0:  sprintf(tmpStr,"High");
	       break;
      case 1:  sprintf(tmpStr,"Low");
	       break;
      case 2:  sprintf(tmpStr,"Critical");
	       break;
      case 3:  sprintf(tmpStr,"Charging");
	       break;
      default:  sprintf(tmpStr,"Unknown");
		break;
   }
   dlgedit_Label_12->setText( tmpStr);
   sprintf(tmpStr,"%d%%",info.bateryLive);
   dlgedit_Label_11->setText( tmpStr);
   tmpStr[0]=0;
   tmpStr1[0]=0;
   if (info.bateryFlag&1) sprintf(tmpStr1,"High");
   strcpy(tmpStr,tmpStr1);
   if (info.bateryFlag&2) sprintf(tmpStr1,"Low %s",tmpStr);
   strcpy(tmpStr,tmpStr1);
   if (info.bateryFlag&4) sprintf(tmpStr1,"Critical %s",tmpStr);
   strcpy(tmpStr,tmpStr1);
   if (info.bateryFlag&8) sprintf(tmpStr1,"Charging %s",tmpStr);
   strcpy(tmpStr,tmpStr1);
   if (info.bateryFlag==0xff) sprintf(tmpStr,"Unknown");
   strcpy(tmpStr,tmpStr1);
   dlgedit_Label_15->setText( tmpStr);
   tmpStr[0]=0;
   tmpStr1[0]=0;
   if (info.apmFlag&1) sprintf(tmpStr1,"16 Bits support");
   strcpy(tmpStr,tmpStr1);
   if (info.apmFlag&2) sprintf(tmpStr1,"32 Bits support %s",tmpStr);
   strcpy(tmpStr,tmpStr1);
   if (info.apmFlag&4) sprintf(tmpStr1,"Idle Slows Clock %s",tmpStr);
   strcpy(tmpStr,tmpStr1);
   if (info.apmFlag&8) sprintf(tmpStr1,"APM disabled %s",tmpStr);
   strcpy(tmpStr,tmpStr1);
   if (info.apmFlag&16) sprintf(tmpStr1,"APM disengaged %s",tmpStr);
   strcpy(tmpStr,tmpStr1);
   if (info.apmFlag==0xff) sprintf(tmpStr1,"Unknown");
   strcpy(tmpStr,tmpStr1);
   dlgedit_Label_14->setText( tmpStr);

   /* now the remaining battery live */
   if (info.remainingLive < 0)
	   dlgedit_Label_17->setText("unknown");
   else {
	   sprintf(tmpStr, "%d %s", info.remainingLive, info.time);
	   dlgedit_Label_17->setText(tmpStr);
   } 

}

int DockView::getHex(char *onzR)
{
   int t=0,ret=0;
   if (onzR[0]!='0' || onzR[1]!='x')
      return -1;
   if (onzR[2]>='0' && onzR[2]<='9')
      ret=onzR[2]-'0';
   else
      if (toupper(onzR[2])>='A' && toupper(onzR[2])<='F')
      ret=toupper(onzR[2])-'A'+10;
   else
      ret=-1;
   if (onzR[3]>='0' && onzR[3]<='9')
      t=onzR[3]-'0';
   else
      if (toupper(onzR[3])>='A' && toupper(onzR[3])<='F')
      t=toupper(onzR[3])-'A'+10;
   else
      t=-1;
   if (t==-1 || ret==-1 )
      return -1;
   if (ret==0)
      ret=t;
   else
      if (t==0)
      ret=t;
   else
      ret=t*ret;

   return ret;
}

void DockView::getApmInfo()
{
   if (noAPM==0)
   {
      if ((file=fopen("/proc/apm","r"))==NULL)
      {
	 noAPM=1;
      }
      else
      {
	 fscanf(file,"%3s %3s %x %x %x %x %d%% %d %3s",
		 (info.apmVersion),
		 (info.biosVersion),
		&(info.apmFlag),
		&(info.ACStatus),
		&(info.bateryStatus),
		&(info.bateryFlag),
		&(info.bateryLive),
		&(info.remainingLive),
		 (info.time));
	 fclose(file);
	 
	 /* CC: now turn on the blink timer if it is not already running */
	 if ((!blink_timer) && (info.bateryStatus == 3) )
		 blink_timer = startTimer(1000);
	 if ((blink_timer) && (info.bateryStatus != 3)) {
		 killTimer(blink_timer);
		 blink_timer = 0;
	 }
      }
   }
   if (noAPM==1)
   {
      sprintf(onz,"Not Installed");
      strcpy(info.biosVersion,onz);
      strcpy(info.apmVersion,onz);
      info.apmFlag=0;
      info.bateryStatus=0;
      info.bateryFlag=0;
      info.bateryLive=0;
      noAPM=2;

   }
}

void DockView::mouseDoubleClickEvent(QMouseEvent *)
{
   QPoint tmp(0,52);
   if (DD==1) showWindow();
   else	if (DD==2) menu->popup(pos()-tmp,1);
}

void DockView::mousePressEvent(QMouseEvent *M)
{
   QPoint tmp(0,52);
   if (M->button() & RightButton)
      if (RC==2) menu->popup(pos()-tmp,1);
   else if (RC==1) showWindow();
}

void DockView::stop()
{
   kapp->quit();
}
void DockView::help()
{
   kapp->invokeHTMLHelp("kapm/kapm.html","");
}


void DockView::suspend()
{
   QString hlp;
   int fd;
   fd = open("/dev/apm_bios", O_RDONLY);
   if (0 > fd) {
	   hlp.append("Cannot open \"/dev/apm_bios\".\n");
	   hlp.append("Reason: ");
	   hlp.append(strerror(errno));
	   hlp.append("\nCannot suspend your computer.");
	   QMessageBox::information(0, "KDE APM Monitor", hlp);
	   return;
   }

   sync();
   sync();
   sleep(2);
   if (0 != ioctl(fd, APM_IOC_SUSPEND, NULL)) {
	   hlp.append("Cannont issue suspend request.\n");
	   hlp.append("Reason: ");
	   hlp.append(strerror(errno));
	   hlp.append("\nCannot suspend your computer.");
	   QMessageBox::information(this, "KDE APM Monitor", hlp);
   }
   ::close(fd);
}




void DockView::standby()
{
   QString hlp;
   int fd;
   fd = open("/dev/apm_bios", O_RDONLY);
   if (0 > fd) {
	   hlp.append("Cannot open \"/dev/apm_bios\".\n");
	   hlp.append("Reason: ");
	   hlp.append(strerror(errno));
	   hlp.append("\nCannot switch your computer to standby.");
	   QMessageBox::information(0, "KDE APM Monitor", hlp);
	   return;
   }

   sync();
   sync();
   sleep(2);
   if (0 != ioctl(fd, APM_IOC_STANDBY, NULL)) {
	   hlp.append("Cannont issue standby request.\n");
	   hlp.append("Reason: ");
	   hlp.append(strerror(errno));
	   hlp.append("\nCannot switch your computer to standby.");
	   perror("kapm");
	   QMessageBox::information(this, "KDE APM Monitor", hlp);
   }
   ::close(fd);
}


/*
void DockView::standby()
{
   if (0 <= v->fd_apm_bios) {
	   sync();
	   sync();
	   sleep(2);
	   if (0 != ioctl(v->fd_apm_bios, APM_IOC_STANDBY, NULL)) {
		   perror("kapm");
		   QMessageBox::information(this, "KDE APM Monitor",
					    "Cannot switch to standby mode\n");
	   }
   }
}
*/

void DockView::showWindow()
{
   if(0 != batw) {	
	   KWM::activate(batw->winId());
   } else {
	   batw=new batwin();
   }
}

DockView::DockView()
{
   int fd;
   int item_id[2];
   KConfig *config;
   QString hlp;

   il=new KIconLoader;
   QString tmp;
   tmp=KApplication::kde_datadir()+"/kapm/icons";
   il->insertDirectory(0,tmp.data());
   noAPM=0;
   iconOn=1;
   iconChargeOn=1;

   /* CC: now read in the saved configuration data */
   config = kapp->getConfig();
   if (config) {
	   config->setGroup("Settings");
	   chkInterval = config->readNumEntry("ChkInterval", 1000);
	   RC = config->readNumEntry("RightClick", 2);
	   DD = config->readNumEntry("DoubleClick", 1);
	   lowBattLevel = config->readNumEntry("LowBattWarning", 10);
   }
   /* CC: at least one button has to be bound to either the menu or the setup dialog */
   if ((0 == RC) && (0 == DD)) {
	   /* CC: default to standard */
	   RC = 2;
	   DD = 1;
   }


   getApmInfo();
   getApmPix();
   update_timer = startTimer(chkInterval);
   blink_timer = 0;
   batw=0;
  
   menu=new QPopupMenu();
   CHECK_PTR(menu);
   menu->insertItem("&Status/Setup",this,SLOT(showWindow()));
   menu->insertItem("&Help",this,SLOT(help()));
   menu->insertSeparator();

   /* CC: Add support for suspend/standby */
   item_id[0] = menu->insertItem("S&tandby",this, SLOT(standby()));
   item_id[1] = menu->insertItem("S&uspend",this, SLOT(suspend()));
   menu->insertSeparator();


   /* CC: try to open /dev/apm_bios */
   fd = open("/dev/apm_bios", O_RDONLY);
   if (0 > fd) {
	   hlp.append("Cannot open \"/dev/apm_bios\".\nReason: ");
	   hlp.append(strerror(errno));
	   hlp.append("\nYou will not be able to switch to standby or suspend.");
	   QMessageBox::warning(0, "KDE APM Monitor",hlp);

	   menu->setItemEnabled(item_id[0], FALSE);
	   menu->setItemEnabled(item_id[1], FALSE);
   } else
	   ::close(fd);
   menu->insertItem("&Quit",this,SLOT(stop()));
}

void DockView::getApmPix()
{
   tijd=info.bateryLive;
   if (tijd>=14) iconOn=1;
   if (info.ACStatus==1)
   {
      if (info.bateryStatus==3)
      {
	 if (iconChargeOn)
	 {
	    pix=il->loadIcon("plugc.xpm",0,0);
	 }
	 else
	 {
	    pix=il->loadIcon("plug.xpm",0,0);
	 }
	 /* CC: Toggling of icon charge is now handled by blink_timer */
      }
      else
	 pix=il->loadIcon("plug.xpm",0,0);
      iconOn=1;
   }
   else
      if (tijd>=86)
      pix=il->loadIcon("bat6.xpm",0,0);
   else
      if (tijd>=72)
      pix=il->loadIcon("bat5.xpm",0,0);
   else
      if (tijd>=58)
      pix=il->loadIcon("bat4.xpm",0,0);
   else
      if (tijd>=43)
      pix=il->loadIcon("bat3.xpm",0,0);
   else
      if (tijd>=29)
      pix=il->loadIcon("bat2.xpm",0,0);
   else
      if (tijd>=14)
      pix=il->loadIcon("bat1.xpm",0,0);
   else
      if (iconOn==1)
      {
	 iconOn=!iconOn;
	 pix=il->loadIcon("bat0.xpm",0,0);
      }
   else
   {
      iconOn=!iconOn;
   }
}

void DockView::timerEvent(QTimerEvent *e)
{
   char tmp[100];

   if (e->timerId() == blink_timer) {
	 iconChargeOn=!iconChargeOn;
   }

   getApmInfo();
   getApmPix();
   dshow();

   if (e->timerId() == update_timer) {
	   updateTooltip();
	   if ((1 != info.ACStatus) && /* don't warn if we are on AC power */
	       (info.bateryLive != old_battery_level) && 
	       (info.bateryLive <= lowBattLevel)
	       ) {
		   /* Display Warning about low battery live */
		   old_battery_level = info.bateryLive;
		   sprintf(tmp, "Low Battery: %d%% remaining", info.bateryLive);
		   kapp->beep();
		   QMessageBox::warning(0, "KDE Power Monitor", tmp);
	   }
   }
}


void DockView::updateTooltip()
{
	char msg[256];

	msg[0] = '\0';
	if(noAPM)
		QToolTip::add(this, "No APM Support");
	else {
		if (1 == info.ACStatus)
			strcat(msg,"AC Power");
		else {
			if (info.remainingLive < 0)
				sprintf(msg,"Bat: %d%%", info.bateryLive);
			else
				sprintf(msg,"Bat: %d%% (~%d %s left)", info.bateryLive, 
					info.remainingLive, info.time);
		}
		QToolTip::add(this, msg);
	}
}


void DockView::dshow()
{
   QPixmap pm(size());
   QPainter p;

   pm.fill(backgroundColor());
   p.begin(&pm);

   if (iconOn) p.drawPixmap(2,0,pix);

   p.end();
   bitBlt(this,0,0,&pm);
}

void DockView::paintEvent( QPaintEvent * )
{
   dshow();
}


DockView::~DockView()
{
}


int main( int argc, char **argv )
{
   KApplication a( argc, argv );
   KWM *b=new KWM;

   v=new DockView;
   a.setMainWidget( v );
   b->setDecoration(v->winId(),KWM::noDecoration);
   b->setDockWindow(v->winId());

   v->show();
   return a.exec();
}

// EOF
