 // KDE APM-BIOS Header File v 0.1.0




 typedef struct apmInfo
 {
       char apmVersion[4];
       char biosVersion[4];
       unsigned int apmFlag;
       unsigned int ACStatus;
       unsigned int bateryStatus;
       unsigned int bateryFlag;
       unsigned int bateryLive;
       int remainingLive;
       char time[4];
 };
 
 apmInfo info;
 
class batwin: public QTabDialog
 {
       Q_OBJECT
       friend class DockView;
    public:
       batwin();
       ~batwin();
    protected:
       QLabel* dlgedit_Label_9;
       QLabel* dlgedit_Label_10;
       QLabel* dlgedit_Label_11;
       QLabel* dlgedit_Label_12;
       QLabel* dlgedit_Label_13;
       QLabel* dlgedit_Label_14;
       QLabel* dlgedit_Label_15;
       QLabel* dlgedit_Label_17;

       QProgressBar* dlgedit_bateryLiveBar;
       QLCDNumber* dlgedit_LCDNumber;
       KSlider* dlgedit_interval;
       KSlider* dlgedit_lowbatt;
       QRadioButton* dlgedit_DDstatus;
       QRadioButton* dlgedit_DDpopup;
       QRadioButton* dlgedit_DDnone;
       QRadioButton* dlgedit_RCnone;
       QRadioButton* dlgedit_RCpopup;
       QRadioButton* dlgedit_RCstatus;

       void timerEvent(QTimerEvent *);
       //       void paintEvent(QPaintEvent *);
       void showAll(void);
       public slots:
	  virtual void help();
          virtual void done(int);
       protected slots:
	  virtual void stop();
          virtual void apply();  
	  virtual void closeWindow();
 };

class DockView : public QWidget
 {
       Q_OBJECT
       friend class batwin;
    public:
       DockView();
       virtual ~DockView();
       void getApmInfo();
       int getHex(char *);
       void getApmPix();
    private:
       void updateTooltip();
       QPicture *i;
       int tijd;
       FILE *file;
       char finp[50],onz[50];
       QPixmap pix;
       KIconLoader *il;       
       batwin *batw;
       int iconOn,iconChargeOn;
       int noAPM;

       int update_timer;
       int blink_timer; /* CC: Timer controlling the blinking charging icon */

       void dshow();
       QPopupMenu *menu;
       private slots:
	  void showWindow();
       void stop();
       void help();
       void suspend();
       void standby();
    protected:
       void paintEvent(QPaintEvent *);
       void timerEvent(QTimerEvent *);
       void mouseDoubleClickEvent(QMouseEvent *);
       void mousePressEvent(QMouseEvent *);

 };

 
